;; -*-emacs-lisp-*-
;;
;; Emacs startup file for the Debian GNU/Linux cmail package
;;
;; Originally contributed by Nils Naumann <naumann@unileoben.ac.at>
;; Modified by Dirk Eddelbuettel <edd@debian.org>
;; Adapted for dh-make by Jim Van Zandt <jrv@vanzandt.mv.com>

;; The cmail package follows the Debian/GNU Linux 'emacsen' policy and
;; byte-compiles its elisp files for each 'emacs flavor' (emacs19,
;; xemacs19, emacs20, xemacs20...).  The compiled code is then
;; installed in a subdirectory of the respective site-lisp directory.
;; We have to add this to the load-path:
(or (string= "emacs19" (symbol-name flavor))
    (progn
      (setq load-path (cons (concat "/usr/share/"
                                    (symbol-name flavor)
                                    "/site-lisp/cmail") load-path))

      (autoload 'cmail "cmail" nil t)
      (autoload 'cmail-mail "cmail" nil t)
      (autoload 'cmail-mail-compose "cmail" nil t)

      (define-mail-user-agent
        'cmail-user-agent
        'cmail-mail-compose
        'cmail-send-and-exit
        'kill-buffer
        'cmail-mail-send-hook)

      (setq cmail-spool-directory "/var/spool/mail/")))
