@echo off
rem ---
rem --- simap4 install batch file for Meadow & NTEmacs
rem ---

rem --- Argument
rem ---   elc : Byte compile only
rem ---   all, install or NOARG : install
rem ---   clean : cleanup
rem ---


rem --- check if executed from make.bat
if not "%SUBMAKEOK%"=="OK" goto prnusage
set SUBMAKEOK=

set SIMAPBBC=%EMACS% -batch -q -no-site-file -l makeconf.el
set SIMAPDST=%LISPDIR%\simap4

rem --- check command
set arg1=%1
if "%arg1%"=="" goto install
if "%arg1%"=="all" goto install
if "%arg1%"=="install" goto install
if "%arg1%"=="elc" goto compile
if "%arg1%"=="clean" goto clean
echo Unrecognized argument: specify either 'elc', 'all', 'install', 'clean'
echo Default is 'install' (when no argument is specified.)
goto end

rem --- install
:install

rem --- Check destination directory
if "%LISPDIR%"=="" goto errexit1
if not exist %SIMAPDST% mkdir %SIMAPDST%
copy make1.bat %SIMAPDST% >nul
if not exist %SIMAPDST%\make1.bat mkdir %SIMAPDST%
copy make1.bat %SIMAPDST% >nul
if not exist %SIMAPDST%\make1.bat goto errexit2
del %SIMAPDST%\make1.bat

echo Compiling files...
echo simap4.el
%SIMAPBBC% -f batch-byte-compile simap4.el
echo simap4-console.el
%SIMAPBBC% -f batch-byte-compile simap4-console.el

echo Copying files to %SIMAPDST%...
if exist %SIMAPDST%\simap4.el del %SIMAPDST%\simap4.el
xcopy /k/r simap4.el %SIMAPDST%
if exist %SIMAPDST%\simap4.elc del %SIMAPDST%\simap4.elc
if exist simap4.elc xcopy /k/r simap4.elc %SIMAPDST%
if exist %SIMAPDST%\simap4-console.el del %SIMAPDST%\simap4-console.el
xcopy /k/r simap4-console.el %SIMAPDST%
if exist %SIMAPDST%\simap4-console.elc del %SIMAPDST%\simap4-console.elc
if exist simap4-console.elc xcopy /k/r simap4-console.elc %SIMAPDST%

del simap4.elc
del simap4-console.elc

echo Done. Please set load-path to include %SIMAPDST% if necessary.
goto end

rem --- compile
:compile
echo Compiling files...
echo simap4.el
%SIMAPBBC% -f batch-byte-compile simap4.el
echo simap4-console.el
%SIMAPBBC% -f batch-byte-compile simap4-console.el
goto end

rem --- |
:clean
echo Deleting *.elc
del *.elc
echo Deleting *~
del *~
echo Done.
goto end

:errexit1
echo Error: variable LISPDIR is not specified.
goto pauseend

:errexit2
echo Error: cannot access install directory %SIMAPDST%
goto pauseend

:printenv
echo EMACS=%EMACS%
echo LISPDIR=%LISPDIR%
goto pauseend

:prnusage
echo This file should not be executed by itself. Use makeit.bat.

:pauseend
echo Type any key when you're done reading the error message.
pause

rem --- end of makeit.bat
:end
set SIMAPBBC=
set SIMAPDST=
